from django.conf.urls.defaults import *
from web.controllers.user import UserController
from web.controllers.file import FileController
from web.controllers.project import ProjectController
from web.controllers.project_type import ProjectTypeController
from web.controllers.compile import CompileController
from web.controllers.root import RootController

api_urls = patterns('',
    (r'^users/(.*)', UserController()),
    (r'^files/(.*)', FileController()),
    (r'^projects/(.*)', ProjectController()),
    (r'^project_types/(.*)', ProjectTypeController()),
    (r'^compile/(.*)', CompileController()),
)

urlpatterns = patterns('',
    (r'^$', RootController()),
    (r'^api/', include(api_urls)),
)
