# coding=UTF-8
from web import models
from web.views import ActualController
from web.services import account, project, files, compiler
from django.http import Http404, HttpResponse
from django.utils import simplejson

__author__ = 'IoS'

class CompileController(ActualController):
    def start(self, request, url, user, method, project_name, *parts):
        a = account.AccountService().get_account(user)
        p = project.ProjectService().get_project(project_name)
        if project.ProjectService().check_write_rights(a, p):
            state_id = request.GET.get("state_id", None)
            branch = request.GET.get("branch", None)
            file_id = request.GET["file_id"]
            start_params = request.GET.get("start_params", "{}")
            try:
                start_params = simplejson.loads(start_params)
            except Exception:
                start_params = {}
            if state_id is not None:
                state = models.ProjectState([models.ProjectState.get_by_id(int(state_id))])[0]
                if state.project != p or (branch is not None and state.tag != branch):
                    raise Http404
            else:
                state = files.FileService().get_last_project_state(p, branch if branch is not None else "master")
            file = models.FileVersion.get_by_id(int(file_id))
            if file is None:
                raise Http404
            logged_res = compiler.CompileService().launch(file, state, p, start_params)
            return HttpResponse(simplejson.dumps({"success": True, "data": logged_res}))
        return HttpResponse(simplejson.dumps({"success": False}))

    def processes(self, request, url, user, method, *parts):
        a = account.AccountService().get_account(user)
        files = [f for f in set([f.name for f in models.FileVersion.all().filter('type =', models.FileType.all().filter('extension =', 'fpml')[0])])]
        return HttpResponse(simplejson.dumps({"success": True, "data": files}))