/**
 * User: progsdi
 * Date: 27.06.12
 * Time: 16:35
 */
var CommonImageEditor = function(desk, project, file) {
    this.desk = desk;
    this.project = project;
    this.file = file;
    this.imgContainer = undefined;
    this.img = undefined;
};
CommonImageEditor.prototype.buildPath = function() {
    return "/api/files/browse/" + this.project.link_name + "/" + (this.file.category && this.file.category.length ? this.file.category + "/" : "") + this.file.name + (this.file.type.extension && this.file.type.extension.length ? "." + this.file.type.extension : "")+ "?_rnd=" + this.desk.utils.generateRandom(8);
};
CommonImageEditor.prototype.activated = function(editorZone) {
    editorZone.children().remove();
    this.imgContainer = $("<div>");
    this.imgContainer.css("width", "100%");
    this.imgContainer.css("height", "100%");
    this.imgContainer.css("overflow", "auto");
    this.imgContainer.css("text-align", "center");
    this.img = $("<img>");
    this.img.attr("src", this.buildPath());
    this.imgContainer.append(this.img);
    editorZone.append(this.imgContainer);
};
CommonImageEditor.prototype.fileChanged = function(modification) {
    if (this.imgContainer) {
        this.file = modification.newFile;
        this.img.attr("src", this.buildPath());
    }
};
CommonImageEditor.editorName = function() { return "Image View"; };
CommonImageEditor.produce = function(desk, project, file) {
    return new CommonImageEditor(desk, project, file);
};
CommonImageEditor.id = "CommonImageEditor";
/* plugging into IDE */
function getEditorFactory() {
    return CommonImageEditor;
}