/**
 * User: progsdi
 * Date: 27.06.12
 * Time: 16:35
 */
var CommonTextEditor = function(desk, project, file) {
        this.desk = desk;
        this.project = project;
        this.file = file;
        this.textarea = undefined;
        this.modified = function() {
            this.desk.fileObj.notifyModification(this.project, this, this.file, this.textarea.val());
        }
    };
CommonTextEditor.prototype.activated = function(editorZone) {
    editorZone.children().remove();
    this.textarea = $("<textarea>");
    this.textarea.css("width", "100%");
    this.textarea.css("height", "100%");
    this.textarea.val(this.file.content);
    if (this.file.is_writable) {
        this.textarea.bind('keyup change', this, function(event) {
            event.data.modified();
        });
    } else {
        this.textarea.prop("readonly", true);
    }
    editorZone.append(this.textarea);
};
CommonTextEditor.prototype.fileChanged = function(modification) {
    modification.newFile.content = this.file.content;
    this.file = modification.newFile;
    if (this.textarea && modification.source != this) {
        this.textarea.val(this.file.content);
    }
};
CommonTextEditor.editorName = function() { return "Common Text"; };
CommonTextEditor.produce = function(desk, project, file) {
    return new CommonTextEditor(desk, project, file);
};
CommonTextEditor.id = "CommonTextEditor";
/* plugging into IDE */
function getEditorFactory() {
    return CommonTextEditor;
}